<template>
  <div>
    <el-breadcrumb separator=">">
      <el-breadcrumb-item :to="{ path: '/' }">首页</el-breadcrumb-item>
      <el-breadcrumb-item>
        <a href="#">系统管理</a>
      </el-breadcrumb-item>
      <el-breadcrumb-item>
        <a href="/company">企业信息管理</a>
      </el-breadcrumb-item>
    </el-breadcrumb>
    <el-divider></el-divider>
    <!--
      要resetFields起作用，必须配置:model和prop
    -->
    <el-form
      ref="queryForm"
      :model="queryModel"
      inline
      class="demo-form-inline"
    >
      <el-form-item label="企业名称" prop="name">
        <el-input type="text" size="mini" v-model="queryModel.name" placeholder="请输入企业名称"></el-input>
      </el-form-item>
      <el-form-item label="企业规模" prop="scale">
        <el-select
          v-model="queryModel.scale"
          filterable
          placeholder="请选择企业规模"
          size="mini"
        >
          <el-option
            v-for="scale in scaleResult"
            :key="scale.value"
            :label="scale.name"
            :value="scale.value"
          ></el-option>
        </el-select>
      </el-form-item>
      <el-form-item label="所属行业" prop="industry">
        <el-select
          v-model="queryModel.industry"
          filterable
          placeholder="请选择所属行业"
          size="mini"
        >
          <el-option
            v-for="industry in industryResult"
            :key="industry.value"
            :label="industry.name"
            :value="industry.value"
          ></el-option>
        </el-select>
      </el-form-item>
      <el-form-item label="是否企业认证" prop="isCertification">
        <el-select size="mini" v-model="queryModel.isCertification" placeholder="请选择是否企业认证">
          <el-option label="是" value="1"></el-option>
          <el-option label="否" value="0"></el-option>
        </el-select>
      </el-form-item>
      <el-form-item>
        <el-button
          type="primary"
          size="mini"
          icon="ios-search"
          @click="changePage(1)"
          :loading="loading"
          >查询</el-button
        >&nbsp;
        <el-button
          type="info"
          size="mini"
          style="margin-left: 8px"
          @click="handleReset('queryForm')"
          >重置</el-button
        >&nbsp;
      </el-form-item>
    </el-form>
    <el-divider></el-divider>
    <el-row class="button-group">
      <el-button
        type="primary"
        size="small"
        plain
        icon="el-icon-circle-plus"
        @click="handleAdd"
        >新增</el-button
      >
      <el-button
        type="primary"
        size="small"
        plain
        icon="el-icon-circle-plus"
        :disabled="multipleSelection.length == 0"
        @click="handleBatchDelete"
        >删除选中项</el-button
      >
    </el-row>
    <el-table
      :data="tableData"
      style="min-height: 400px"
      v-loading="loading"
      stripe
      @sort-change="sortChange"
      @selection-change="handleSelectionChange"
    >
      <el-table-column type="selection" width="55"></el-table-column>
      <el-table-column
        prop="name"
        label="企业名称"
        width="220"
      ></el-table-column>
      <el-table-column
        prop="logo"
        label="logo"
        width="80"
        fixed="left"
      >
        <template slot-scope="{ row }">
          <a :href="row.logo" target="_blank">
            <el-avatar
              :size="48"
              shape="circle"
              :src="row.logo + '?x-oss-process=image/resize,m_fill,w_64,h_64'"
              :key="row.id"
            ></el-avatar>
          </a>
        </template>
      </el-table-column>
      <el-table-column
        prop="scaleName"
        label="企业规模"
        width="100"
      ></el-table-column>
      <el-table-column
        prop="industryName"
        label="所属行业"
        width="180"
      ></el-table-column>
      <el-table-column
        prop="address"
        label="公司地址"
        width="260"
      ></el-table-column>
      <el-table-column prop="isCertification" label="是否企业认证" width="150">
        <template slot-scope="{row}">
          <span v-html="row.isCertification ? '是': '否'"></span>
        </template>
      </el-table-column>
      <el-table-column label="操作">
        <template slot-scope="{ row }">
          <el-button size="mini" type="text" @click="handleEdit(row)">编辑</el-button>
          <el-button size="mini" type="text" @click="handleDelete(row)">删除</el-button>
          <el-button v-if="row.isCertification" size="mini" type="text" @click="handleProve(row)">查看认证</el-button>
          <el-button size="mini" type="text" @click="handlePost(row)">查看职位</el-button>
        </template>
      </el-table-column>
    </el-table>
    <el-pagination
      :current-page.sync="pageIndex"
      :total="totalElements"
      :page-sizes="pageSizeList"
      @current-change="changePage"
      @size-change="pageSizeChange"
      layout="total, sizes, prev, pager, next, jumper"
    ></el-pagination>
    <company-detail
      v-if="showModal"
      :businessKey="businessKey"
      :title="modalTitle"
      @close="onDetailModalClose"
    ></company-detail>
    <company-prove
      v-if="showProve"
      :businessKey="businessKey"
      :title="modalTitle"
      @close="onDetailModalClose"
    ></company-prove>
    <company-post
      v-if="showPost"
      :businessKey="businessKey"
      :title="modalTitle"
      @close="onDetailModalClose"
    ></company-post>
  </div>
</template>
<script>
import Constant from "@/constant";
import CompanyDetail from "./company-detail";
import CompanyProve from "./company-prove";
import CompanyPost from './company-post.vue';
import companyApi from "@/api/base/company";
import dataDictionaryApi from "@/api/sys/dataDictionary";
import NProgress from "nprogress"; // progress bar
import "nprogress/nprogress.css"; // progress bar style

export default {
  data() {
    var self = this;

    return {
      queryModel: {
        name: "",
        type: "",
        scale: "",
        industry: "",
        isCertification:"",
      },
      loading: false,
      tableData: [],
      pageIndex: 1,
      pageSize: 10,
      totalPages: 0,
      totalElements: 0,
      field: "",
      direction: "",
      pageSizeList: [10, 20, 30],
      multipleSelection: [],
      showModal: false,
      showProve: false,
      showPost: false,
      modalTitle: "",
      businessKey: "",
      industryResult: [],
      scaleResult: [],
    };
  },
  created() {
    dataDictionaryApi
    .findByCatalogName({
      catalogName: "所属行业",
    })
    .then((response) => {
      var jsonData = response.data;
      this.industryResult = jsonData.data;
    });

    dataDictionaryApi
    .findByCatalogName({
      catalogName: "企业规模",
    })
    .then((response) => {
      var jsonData = response.data;
      this.scaleResult = jsonData.data;
    });
  },
  methods: {
    changePage(pageIndex) {
      var self = this;

      self.loading = true;

      self.pageIndex = pageIndex;
      var formData = new FormData();

      formData.append("pageIndex", self.pageIndex);
      formData.append("pageSize", self.pageSize);

      formData.append("name", self.queryModel.name);
      formData.append("type", self.queryModel.type);
      formData.append("scale", self.queryModel.scale);
      formData.append("industry", self.queryModel.industry);
      formData.append("isCertification", self.queryModel.isCertification);

      if (this.field != null) {
        formData.append("field", this.field);
      }

      if (this.direction != null) {
        formData.append("direction", this.direction);
      }

      companyApi
        .pageList(formData)
        .then(function (response) {
          self.loading = false;

          var jsonData = response.data.data;

          self.tableData = jsonData.data;
          self.totalPages = jsonData.totalPages;
          self.totalElements = jsonData.recordsTotal;
        })
        .catch((error) => {
          self.loading = false;
          // self.$message.error(error + "");
        });
    },
    pageSizeChange(pageSize) {
      this.pageSize = pageSize;

      this.$nextTick(() => {
        this.changePage(this.pageIndex);
      });
    },
    sortChange(data) {
      this.field = data.column.field;
      this.direction = data.order;

      this.changePage(this.pageIndex);
    },
    handleSelectionChange(val) {
      this.multipleSelection = val;
    },
    handleReset(name) {
      this.$refs[name].resetFields();
    },
    handleAdd() {
      this.modalTitle = "新增";
      this.businessKey = "";
      this.showModal = true;
    },
    handleEdit(record) {
      this.modalTitle = "编辑";
      this.businessKey = record.id;
      this.showModal = true;
    },
    handleProve(record) {
      this.modalTitle = "认证";
      this.businessKey = record.id;
      this.showProve = true;
    },
    handlePost(record) {
      this.modalTitle = "职位";
      this.businessKey = record.id;
      this.showPost = true;
    },
    handleDelete(record) {
      var self = this;

      self
        .$confirm("是否确认删除?", "提示", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning",
        })
        .then(() => {
          companyApi.remove(record.id).then(function (response) {
            var jsonData = response.data;

            if (jsonData.result) {
              // var index = self.tableData.indexOf(record);
              // self.tableData.splice(index, 1);
              self.changePage(self.pageIndex);

              self.$message({
                type: "success",
                message: "删除成功!",
              });
            }
          });
        });
    },
    handleBatchDelete() {
      var self = this;

      var idList = this.multipleSelection.map((record) => {
        return record.id;
      });

      this.$confirm("是否确认删除选中项？", "提示", {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        type: "warning",
      }).then(() => {
        companyApi.batchRemove(idList).then(function (response) {
          var jsonData = response.data;

          if (jsonData.result) {
            self.changePage(self.pageIndex);

            self.$message({
              type: "success",
              message: "删除成功!",
            });
          }
        });
      });
    },
    onDetailModalClose(refreshed) {
      //保存成功后回调
      this.showModal = false;
      this.showProve = false;
      this.showPost = false;

      if (refreshed) {
        this.changePage(this.pageIndex);
      }
    },
  },
  mounted: function () {
    this.changePage(1);
  },
  components: {
    "company-detail": CompanyDetail,
    "company-prove": CompanyProve,
    "company-post": CompanyPost,
  },
};
</script>
<style lang="scss" scoped>
.el-breadcrumb {
  margin: 10px;
  line-height: 20px;
}

.el-divider {
  margin: 5px 0;
}

.demo-form-inline {
  margin-left: 10px;
  text-align: left;
}

.button-group {
  margin-left: 10px;
  text-align: left;
}
</style>